const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Revenue_summariesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const revenue_summaries = await db.revenue_summaries.create(
      {
        id: data.id || undefined,

        month: data.month || null,
        total_amount: data.total_amount || null,
        payer_breakdown: data.payer_breakdown || null,
        growth_pct: data.growth_pct || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await revenue_summaries.setOrganization(
      currentUser.organization.id || null,
      {
        transaction,
      },
    );

    await revenue_summaries.setOrganizations(data.organizations || null, {
      transaction,
    });

    return revenue_summaries;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const revenue_summariesData = data.map((item, index) => ({
      id: item.id || undefined,

      month: item.month || null,
      total_amount: item.total_amount || null,
      payer_breakdown: item.payer_breakdown || null,
      growth_pct: item.growth_pct || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const revenue_summaries = await db.revenue_summaries.bulkCreate(
      revenue_summariesData,
      { transaction },
    );

    // For each item created, replace relation files

    return revenue_summaries;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const revenue_summaries = await db.revenue_summaries.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.month !== undefined) updatePayload.month = data.month;

    if (data.total_amount !== undefined)
      updatePayload.total_amount = data.total_amount;

    if (data.payer_breakdown !== undefined)
      updatePayload.payer_breakdown = data.payer_breakdown;

    if (data.growth_pct !== undefined)
      updatePayload.growth_pct = data.growth_pct;

    updatePayload.updatedById = currentUser.id;

    await revenue_summaries.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await revenue_summaries.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await revenue_summaries.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return revenue_summaries;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const revenue_summaries = await db.revenue_summaries.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of revenue_summaries) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of revenue_summaries) {
        await record.destroy({ transaction });
      }
    });

    return revenue_summaries;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const revenue_summaries = await db.revenue_summaries.findByPk(id, options);

    await revenue_summaries.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await revenue_summaries.destroy({
      transaction,
    });

    return revenue_summaries;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const revenue_summaries = await db.revenue_summaries.findOne(
      { where },
      { transaction },
    );

    if (!revenue_summaries) {
      return revenue_summaries;
    }

    const output = revenue_summaries.get({ plain: true });

    output.organization = await revenue_summaries.getOrganization({
      transaction,
    });

    output.organizations = await revenue_summaries.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.month) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('revenue_summaries', 'month', filter.month),
        };
      }

      if (filter.payer_breakdown) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'revenue_summaries',
            'payer_breakdown',
            filter.payer_breakdown,
          ),
        };
      }

      if (filter.total_amountRange) {
        const [start, end] = filter.total_amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            total_amount: {
              ...where.total_amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            total_amount: {
              ...where.total_amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.growth_pctRange) {
        const [start, end] = filter.growth_pctRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            growth_pct: {
              ...where.growth_pct,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            growth_pct: {
              ...where.growth_pct,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.revenue_summaries.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('revenue_summaries', 'month', query),
        ],
      };
    }

    const records = await db.revenue_summaries.findAll({
      attributes: ['id', 'month'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['month', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.month,
    }));
  }
};
